
#ifndef BATTERY_H__
#define BATTERY_H__

#include <stdint.h> 
#include <stdio.h>
#include "access_reliable.h"
#include "generic_onoff_messages.h"
#include "access.h"

typedef struct __generic_battery_client_t generic_battery_client_t;

//uint32_t battery_double_init(generic_onoff_server_t * p_server, uint8_t element_index);

typedef union
{
    generic_onoff_set_msg_pkt_t set;
} generic_battery_client_msg_data_t;

typedef void (*generic_battery_state_status_cb_t)(const generic_battery_client_t * p_self,
                                                const access_message_rx_meta_t * p_meta,
                                                const generic_battery_status_params_t * p_in);
typedef struct
{
  generic_battery_state_status_cb_t battery_status_cb;

  access_reliable_cb_t ack_transaction_status_cb;

  access_publish_timeout_cb_t periodic_publish_cb;
}generic_battery_client_callbacks_t;

typedef struct
{
    /** Reliable message timeout in microseconds. If this value is set to zero, during model
     * initialization this value will be updated to the value specified by
     * by @ref MODEL_ACKNOWLEDGED_TRANSACTION_TIMEOUT. */
    uint32_t timeout;
    /** If server should force outgoing messages as segmented messages */
    bool force_segmented;
    /** TransMIC size used by the outgoing server messages. See @ref nrf_mesh_transmic_size_t */
    nrf_mesh_transmic_size_t transmic_size;

    /** Callback list */
    const generic_battery_client_callbacks_t * p_callbacks;
} generic_battery_client_settings_t;
/**  */

struct __generic_battery_client_t
{
    /** Model handle assigned to this instance */
    access_model_handle_t model_handle;
    /** Holds the raw message packet data for transactions */
    generic_battery_client_msg_data_t msg_pkt;
    /* Acknowledged message context variable */
    access_reliable_t access_message;

    /** Model settings and callbacks for this instance */
    generic_battery_client_settings_t settings;
};

//uint32_t battery_double_init(generic_onoff_server_t * p_server, uint8_t element_index);

#endif 